---
-- AnimatedObjectExtend
--
-- 
--
-- Copyright (c) DerElky, 2019


function load(self, superFunc, nodeId, xmlFile, key, xmlFilename)
    local autoopenkey = key .. ".autoOpen"
    self.autoopen= Utils.getNoNil(getXMLBool(xmlFile, autoopenkey.."#use"), false)
	self.playercount = 0
	self.numVehicles = 0	
	local changetriggerId = I3DUtil.indexToObject(nodeId, getXMLString(xmlFile, key..".controls#triggerNode"))
	setCollisionMask(changetriggerId, 11542528)
	
	
	return superFunc(self, nodeId, xmlFile, key, xmlFilename)
end

 function triggerCallback(self, superfunc, triggerId, otherId, onEnter, onLeave, onStay, otherShapeId)   
	
	if g_currentMission.missionInfo:isa(FSCareerMissionInfo) then
			local vehicle = g_currentMission.nodeToObject[otherShapeId]
			--DebugUtil.printTableRecursively(vehicle, 2, 2)
			local pvehicle = false
			if vehicle ~= nil then
				pvehicle = true
			end
			
		local useauto = false
		if self.openingHours ~=nil then
			if self.openingHours.isOpen then
				useauto = true
			else
				useauto = false
			end
		else
			useauto = true
		end
				
		if onEnter or onLeave then
			if self.ownerFarmId == nil or self.ownerFarmId == AccessHandler.EVERYONE or g_currentMission.accessHandler:canFarmAccessOtherId(g_currentMission:getFarmId(), self.ownerFarmId) then
				if g_currentMission.player ~= nil and otherId == g_currentMission.player.rootNode then
					if onEnter then					
						if self.autoopen and useauto then
							self.playercount = self.playercount + 1;
						else						
							self.playerInRange = true
						end
					else 
						if self.autoopen and useauto then
							self.playercount = math.max(self.playercount - 1, 0)
							self.animation.direction = -1
						else					
							self.playerInRange = nil
						end
					end				
				else
					if not g_currentMission.controlPlayer and pvehicle then
						if onEnter then
							if self.autoopen and useauto then
								self.numVehicles = self.numVehicles + 1;
							end
						else 
							if self.autoopen and useauto then
								self.numVehicles = math.max(self.numVehicles - 1, 0); 
							end
						end			
					end
				end
			end
			self:raiseActive()
			if self.autoopen and useauto then
				if (self.playercount > 0 or self.numVehicles > 0) then
					self.animation.direction = 1
				else
					self.animation.direction = -1
				end	
			end	
		end
   end
end


AnimatedObject.load = Utils.overwrittenFunction(AnimatedObject.load, load)
AnimatedObject.triggerCallback = Utils.overwrittenFunction(AnimatedObject.triggerCallback, triggerCallback)
